//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#define String AnsiString
#include "UnitM.h"
#include "UnitF.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormM *FormM;
bool fBold=false;
bool fItal=false;
String Dir;
int Kx=-1, Ky=-1;
//---------------------------------------------------------------------------
__fastcall TFormM::TFormM(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void ReDraw(void)
{
TFontStyles a=TFontStyles();
FormM->StringGrid1->Font->Size=FormM->Edit1->Text.ToInt();
FormM->StringGrid1->Font->Name=FormM->ComboBox1->Text;
if(fBold)a=a<<fsBold;
if(fItal)a=a<<fsItalic;
FormM->StringGrid1->Font->Style=a;
FormM->Button3->Font->Style=a;
FormM->Button4->Font->Style=a;

for(int i=0; i<28; i++)
for(int j=0; j<8; j++)
FormM->StringGrid1->Cells[i][j]=String(char(32+i+j*28));
}
//---------------------------------------------------------------------------
void Setka(void)
{
FormM->Image1->Canvas->Pen->Color=clBlue;
FormM->Image1->Canvas->MoveTo(0, 0);
FormM->Image1->Canvas->LineTo(28*8*2+28, 0);
FormM->Image1->Canvas->LineTo(28*8*2+28, 8*8*2+8);
FormM->Image1->Canvas->LineTo(0, 8*8*2+8);
FormM->Image1->Canvas->LineTo(0, 0);
for(int i=1; i<8; i++)
  {
  FormM->Image1->Canvas->MoveTo(0, i*(8*2+1));
  FormM->Image1->Canvas->LineTo(28*8*2+28, i*(8*2+1));
  }
for(int i=1; i<28; i++)
  {
  FormM->Image1->Canvas->MoveTo(i*(8*2+1), 0);
  FormM->Image1->Canvas->LineTo(i*(8*2+1), 8*8*2+8);
  }
FormM->Image1->Canvas->Pen->Color=clBlack;
}
//---------------------------------------------------------------------------
void __fastcall TFormM::FormActivate(TObject *Sender)
{
Dir=ExtractFilePath(ParamStr(0));
if(Dir.SubString(Dir.Length(), 1)!='\\')Dir+="\\";
ComboBox1->Items=Screen->Fonts;
ReDraw();
Setka();
}
//---------------------------------------------------------------------------
void __fastcall TFormM::ComboBox1Change(TObject *Sender)
{
ReDraw();
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button3Click(TObject *Sender)
{
fBold=!fBold;
ReDraw();
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button4Click(TObject *Sender)
{
fItal=!fItal;
ReDraw();        
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Edit1Change(TObject *Sender)
{
ReDraw();        
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button1Click(TObject *Sender)
{
Setka();
StringGrid1->Col=0;
StringGrid1->Row=0;
for(int x=0; x<28; x++)
for(int y=0; y<8; y++)
  {
  int aa=x*(8*2+1)+Edit4->Text.ToInt();
  int bb=y*(8*2+1)+Edit5->Text.ToInt();
  int a=x*(8*2+1)+1;
  int b=y*(8*2+1)+1;
  for(int i=0; i<8; i++)
  for(int j=0; j<8; j++)
    {
    TColor c=StringGrid1->Canvas->Pixels[aa+i][bb+j];
    if(c!=clBlack)c=clWhite;
    Image1->Canvas->Pixels[a+i*2][b+j*2]=c;
    Image1->Canvas->Pixels[a+i*2+1][b+j*2]=c;
    Image1->Canvas->Pixels[a+i*2][b+j*2+1]=c;
    Image1->Canvas->Pixels[a+i*2+1][b+j*2+1]=c;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormM::StringGrid1Click(TObject *Sender)
{
Kx=StringGrid1->Col;
Ky=StringGrid1->Row;
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Image1MouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
int x=(X-1)/(8*2+1);
int y=(Y-1)/(8*2+1);
int aa=Kx*(8*2+1)+Edit4->Text.ToInt();
int bb=Ky*(8*2+1)+Edit5->Text.ToInt();
int a=x*(8*2+1)+1;
int b=y*(8*2+1)+1;

if(Kx<0 || Ky<0)
  {
  FormF->Image1->Canvas->Pen->Color=clBlue;
  FormF->Image1->Canvas->MoveTo(0, 0);
  FormF->Image1->Canvas->LineTo(136, 0);
  FormF->Image1->Canvas->LineTo(136, 136);
  FormF->Image1->Canvas->LineTo(0, 136);
  FormF->Image1->Canvas->LineTo(0, 0);
  for(int i=1; i<8; i++)
    {
    FormF->Image1->Canvas->MoveTo(0, i*(8*2+1));
    FormF->Image1->Canvas->LineTo(28*8*2+28, i*(8*2+1));
    }
  for(int i=1; i<8; i++)
    {
    FormF->Image1->Canvas->MoveTo(i*(8*2+1), 0);
    FormF->Image1->Canvas->LineTo(i*(8*2+1), 8*8*2+8);
    }
  FormF->Image1->Canvas->Pen->Color=clBlack;

  FormF->Image2->Canvas->Pen->Color=clBlue;
  FormF->Image2->Canvas->MoveTo(16, 16);
  FormF->Image2->Canvas->LineTo(33, 16);
  FormF->Image2->Canvas->LineTo(33, 33);
  FormF->Image2->Canvas->LineTo(16, 33);
  FormF->Image2->Canvas->LineTo(16, 16);
  FormF->Image2->Canvas->Pen->Color=clBlack;

  for(int i=0; i<16; i++)
  for(int j=0; j<16; j++)
    {
    FormF->Image2->Canvas->Pixels[17+i][17+j]=Image1->Canvas->Pixels[a+i][b+j];
    for(int k=0; k<8; k++)
    for(int l=0; l<8; l++)
      FormF->Image1->Canvas->Pixels[i*8.5+k+1][j*8.5+l+1]=Image1->Canvas->Pixels[a+i][b+j];
    }
  FormF->ShowModal();
  for(int i=0; i<16; i++)
  for(int j=0; j<16; j++)
    Image1->Canvas->Pixels[a+i][b+j]=FormF->Image2->Canvas->Pixels[17+i][17+j];
  return;
  }

for(int i=0; i<8; i++)
for(int j=0; j<8; j++)
  {
  TColor c=StringGrid1->Canvas->Pixels[aa+i][bb+j];
  if(c!=clBlack)c=clWhite;
  Image1->Canvas->Pixels[a+i*2][b+j*2]=c;
  Image1->Canvas->Pixels[a+i*2+1][b+j*2]=c;
  Image1->Canvas->Pixels[a+i*2][b+j*2+1]=c;
  Image1->Canvas->Pixels[a+i*2+1][b+j*2+1]=c;
  }
Kx=Ky=-1;
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button5Click(TObject *Sender)
{
OpenDialog1->InitialDir=Dir;
if(OpenDialog1->Execute())
  {
  if(FileExists(OpenDialog1->FileName))Image1->Picture->LoadFromFile(OpenDialog1->FileName);
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button6Click(TObject *Sender)
{
Memo1->Align=alClient;
Memo1->Lines->LoadFromFile(Dir+"help.txt");
Memo1->Visible=true;
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Memo1Click(TObject *Sender)
{
Memo1->Visible=false;
}
//---------------------------------------------------------------------------
#define _p Image1->Canvas->Pixels
//---------------------------------------------------------------------------
int BW(TColor c)
{
if(c==clBlack)return(1);
else return(0);
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button2Click(TObject *Sender)
{
Image1->Picture->SaveToFile(Dir+FormatDateTime("ddmmyyhhnnss", Now())+".bmp");
FILE *tg=fopen((Dir+FormatDateTime("ddmmyyhhnnss", Now())+".c").c_str(), "w");
if(tg!=NULL)
  {
  fprintf(tg, "// **********************************************\n");
  fprintf(tg, "//      32    255.\n");
  fprintf(tg, "//    .\n");
  if(RadioButton1->Checked)
    {
    fprintf(tg, "//    .\n");
    if(CheckBox1->Checked)fprintf(tg, "//   .\n");
    else fprintf(tg, "//   .\n");
    }
  else
    {
    fprintf(tg, "//    .\n");
    if(CheckBox1->Checked)fprintf(tg, "//   .\n");
    else fprintf(tg, "//   .\n");
    }
  fprintf(tg, "// **********************************************\n\n");
  fprintf(tg, "__flash static unsigned char FONT[8*224]=\n");
  fprintf(tg, "  {\n");

  for(int y=0; y<8; y++)
  for(int x=0; x<28; x++)
    {
    int a=x*(8*2+1)+1;
    int b=y*(8*2+1)+1;
    fprintf(tg, "  ");
    for(int i=0; i<16; i+=2)
      {
      BYTE bbb;
      if(RadioButton1->Checked)
        {
        if(CheckBox1->Checked)bbb=128*(BW(_p[a+i][b+0]))+64*(BW(_p[a+i][b+2]))+32*(BW(_p[a+i][b+4]))+16*(BW(_p[a+i][b+6]))+8*(BW(_p[a+i][b+8]))+4*(BW(_p[a+i][b+10]))+2*(BW(_p[a+i][b+12]))+1*(BW(_p[a+i][b+14]));
        else                  bbb=1*(BW(_p[a+i][b+0]))+2*(BW(_p[a+i][b+2]))+4*(BW(_p[a+i][b+4]))+8*(BW(_p[a+i][b+6]))+16*(BW(_p[a+i][b+8]))+32*(BW(_p[a+i][b+10]))+64*(BW(_p[a+i][b+12]))+128*(BW(_p[a+i][b+14]));
        }
      else
        {
        if(CheckBox1->Checked)bbb=128*(BW(_p[a+0][b+i]))+64*(BW(_p[a+2][b+i]))+32*(BW(_p[a+4][b+i]))+16*(BW(_p[a+6][b+i]))+8*(BW(_p[a+8][b+i]))+4*(BW(_p[a+10][b+i]))+2*(BW(_p[a+12][b+i]))+1*(BW(_p[a+14][b+i]));
        else                  bbb=1*(BW(_p[a+0][b+i]))+2*(BW(_p[a+2][b+i]))+4*(BW(_p[a+4][b+i]))+8*(BW(_p[a+6][b+i]))+16*(BW(_p[a+8][b+i]))+32*(BW(_p[a+10][b+i]))+64*(BW(_p[a+12][b+i]))+128*(BW(_p[a+14][b+i]));
        }
      if(y==7 && x==27 && i==7)fprintf(tg, "0x%02x", bbb);
      else fprintf(tg, "0x%02x, ", bbb);
      }
    fprintf(tg, " // code %d (%c)\n", 32+x+y*28, char(32+x+y*28));
    }
  fprintf(tg, "  };\n");
  fclose(tg);
  ShowMessage("OK");
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormM::Button7Click(TObject *Sender)
{
BYTE M[224*8];
BYTE MM[224*8];
int iM=0;
int iMM=0;

int lx=Edit2->Text.ToInt();
int ly=Edit3->Text.ToInt();
if(RadioButton1->Checked)ly=(ly/8)*8; else lx=(lx/8)*8;

FILE *tg=fopen((Dir+FormatDateTime("ddmmyyhhnnss", Now())+".c").c_str(), "w");
if(tg!=NULL)
  {
  fprintf(tg, "// **********************************************\n");
  fprintf(tg, "// BitMap  . (%dx%d)\n", lx, ly);
  if(RadioButton1->Checked)
    {
    fprintf(tg, "//    .\n");
    if(CheckBox1->Checked)fprintf(tg, "//   .\n");
    else fprintf(tg, "//   .\n");
    }
  else
    {
    fprintf(tg, "//    .\n");
    if(CheckBox1->Checked)fprintf(tg, "//   .\n");
    else fprintf(tg, "//   .\n");
    }
  fprintf(tg, "// **********************************************\n\n");
  if(RadioButton1->Checked)fprintf(tg, "__flash static unsigned char PICT[%d*%d]=\n", lx, ly/8);
  else fprintf(tg, "__flash static unsigned char PICT[%d*%d]=\n", lx/8, ly);

  fprintf(tg, "  {\n");

  BYTE bbb;
  if(!RadioButton1->Checked)
    {
    for(int y=0; y<ly; y++)
      {
      if(!CheckBox2->Checked)fprintf(tg, "  ");
      for(int x=0; x<lx; x+=8)
        {
        if(CheckBox1->Checked)bbb=128*(BW(_p[x+0][y]))+64*(BW(_p[x+1][y]))+32*(BW(_p[x+2][y]))+16*(BW(_p[x+3][y]))+8*(BW(_p[x+4][y]))+4*(BW(_p[x+5][y]))+2*(BW(_p[x+6][y]))+1*(BW(_p[x+7][y]));
        else bbb=1*(BW(_p[x+0][y]))+2*(BW(_p[x+1][y]))+4*(BW(_p[x+2][y]))+8*(BW(_p[x+3][y]))+16*(BW(_p[x+4][y]))+32*(BW(_p[x+5][y]))+64*(BW(_p[x+6][y]))+128*(BW(_p[x+7][y]));
        M[iM]=bbb; iM++;
        if(!CheckBox2->Checked)
          {
          if(y==ly-1 && x+8>=lx)fprintf(tg, "0x%02x", bbb);
          else fprintf(tg, "0x%02x, ", bbb);
          }
        }
      if(!CheckBox2->Checked)fprintf(tg, " // line %d\n", y);
      }
    }
  else
    {
    for(int y=0; y<ly; y+=8)
      {
      if(!CheckBox2->Checked)fprintf(tg, "  ");
      for(int x=0; x<lx; x++)
        {
        if(CheckBox1->Checked)bbb=128*(BW(_p[x][y+0]))+64*(BW(_p[x][y+1]))+32*(BW(_p[x][y+2]))+16*(BW(_p[x][y+3]))+8*(BW(_p[x][y+4]))+4*(BW(_p[x][y+5]))+2*(BW(_p[x][y+6]))+1*(BW(_p[x][y+7]));
        else bbb=1*(BW(_p[x][y+0]))+2*(BW(_p[x][y+1]))+4*(BW(_p[x][y+2]))+8*(BW(_p[x][y+3]))+16*(BW(_p[x][y+4]))+32*(BW(_p[x][y+5]))+64*(BW(_p[x][y+6]))+128*(BW(_p[x][y+7]));
        M[iM]=bbb; iM++;
        if(!CheckBox2->Checked)
          {
          if(y+8>=ly && x==lx-1)fprintf(tg, "0x%02x", bbb);
          else fprintf(tg, "0x%02x, ", bbb);
          }
        }
      if(!CheckBox2->Checked)fprintf(tg, " // lines %d...%d\n", y, y+7);
      }
    }
  if(CheckBox2->Checked)
    {
    int k=0;
    for(int i=0; i<iM; i++)
      {
      if(i>1)
        {
        if(M[i-2]==M[i-1] && M[i-1]==M[i] && MM[iMM-2]==M[i] && MM[iMM-1]==M[i])
          {k++; if(k==255){MM[iMM]=k; iMM++; k=0;} continue;}
        if(M[i-2]==M[i-1] && M[i-1]!=M[i])
          {MM[iMM]=k; iMM++; k=0; MM[iMM]=M[i]; iMM++; continue;}
        MM[iMM]=M[i]; iMM++;
        }
      else
        {
        MM[iMM]=M[i];
        iMM++;
        }
      }
    if(k>0){MM[iMM]=k; iMM++;}
    for(int i=0; i<iMM; i++)
      {
      if(!(i&31))fprintf(tg, "\n  ");
      if(i==iMM-1)fprintf(tg, "0x%02x\n", MM[i]);
      else fprintf(tg, "0x%02x, ", MM[i]);
      }
    }
  fprintf(tg, "  };\n");
  if(CheckBox2->Checked)fprintf(tg, "\n\n//   %d .\n", iMM);
  fclose(tg);
  ShowMessage("OK");
  }
}
//---------------------------------------------------------------------------

